package gregapi.network.packets;

import static gregapi.data.CS.ERR;
import static gregapi.data.CS.F;
import gregapi.GT_API;
import gregapi.data.LH;
import gregapi.network.INetworkHandler;
import gregapi.network.IPacket;
import gregapi.util.UT;

import java.io.IOException;
import java.util.List;

import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.CompressedStreamTools;
import net.minecraft.nbt.NBTSizeTracker;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.world.IBlockAccess;

import com.google.common.io.ByteArrayDataInput;
import com.google.common.io.ByteArrayDataOutput;
import com.google.common.io.ByteStreams;

/**
 * @author Gregorius Techneticies
 */
public class PacketItemStackChat implements IPacket {
	private ItemStack mStack;
	
	public PacketItemStackChat() {/**/}
	
	public PacketItemStackChat(ItemStack aStack) {
		mStack = aStack;
	}
	
	@Override
	public byte getPacketID() {
		return 125;
	}
	
	@Override
	public ByteArrayDataOutput encode() {
        ByteArrayDataOutput aData = ByteStreams.newDataOutput();
		aData.writeShort(UT.Stacks.id(mStack));
		aData.writeByte(mStack.stackSize);
		aData.writeShort(UT.Stacks.meta(mStack));
        NBTTagCompound tNBT = mStack.getTagCompound();
        if (tNBT == null) aData.writeShort(-1); else {
        	try {
        		byte[] tData = CompressedStreamTools.compress(tNBT);
                aData.writeShort(tData.length);
                aData.write(tData);
        	} catch (IOException e) {e.printStackTrace(ERR);}
        }
		return aData;
	}
	
	@Override
	public IPacket decode(ByteArrayDataInput aData) {
		return new PacketItemStackChat(UT.Stacks.make(Item.getItemById(aData.readShort()), aData.readByte(), aData.readShort(), readNBTTagCompoundFromBuffer(aData)));
	}
	
    public NBTTagCompound readNBTTagCompoundFromBuffer(ByteArrayDataInput aData) {
        short tLength = aData.readShort();
        if (tLength <= 0) return null;
        byte[] tData = new byte[tLength];
        aData.readFully(tData);
        try {return CompressedStreamTools.func_152457_a(tData, new NBTSizeTracker(2097152L));} catch (IOException e) {e.printStackTrace(ERR);}
        return null;
    }
    
	@Override
	public void process(IBlockAccess aWorld, INetworkHandler aNetworkHandler) {
		UT.Entities.chat(GT_API.api_proxy.getThePlayer(), mStack.func_151000_E());
		List<String> tList = mStack.getTooltip(GT_API.api_proxy.getThePlayer(), F);
		if (tList != null && !tList.isEmpty()) {
			tList.remove(0);
			tList.remove(LH.Chat.DGRAY + "Can be placed inside a GT Bookshelf");
			UT.Entities.chat(GT_API.api_proxy.getThePlayer(), tList, F);
		}
	}
}